﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using SelectAllMvvm.NorthwindService;
using System.Linq;
using System.ComponentModel;

namespace SelectAllMvvm.Assets
{
    public class CustomersViewModel : INotifyPropertyChanged
    {
        private ObservableCollection<Customer> _customers;

        public CustomersViewModel()
        {
            NorthwindService.NorthwindClient client = new NorthwindService.NorthwindClient();
            client.GetCustomersCompleted += new EventHandler<NorthwindService.GetCustomersCompletedEventArgs>(client_GetCustomersCompleted);
            client.GetCustomersAsync();
        }

        void client_GetCustomersCompleted(object sender, NorthwindService.GetCustomersCompletedEventArgs e)
        {
            this.Customers = e.Result;
        }

        public ObservableCollection<Customer> Customers {
            get { return this._customers; }
            set {
                if (value != this._customers)
                {
                    this._customers = value;
                    NotifyPropertyChanged("Customers");
                }
            } 
        }

        public ICommand CheckAllCustomers
        {
            get
            {
                return new GenericCommand(argument =>
                {
                    this.Customers.ToList().ForEach(c => c.IsChecked = (bool)argument);
                },
                argument =>
                {
                    return true;
                });
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
    
    }
   
}
